# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

#' Compute Euclidean distance matrix by rows
#' 
#' Used in consmx function
#' 
#' @param x A numeric matrix.
ED1 <- function(x) {
    .Call('_SC3_ED1', PACKAGE = 'SC3', x)
}

#' Compute Euclidean distance matrix by columns
#' 
#' Used in sc3-funcs.R distance matrix calculation
#' and within the consensus clustering.
#' 
#' @param x A numeric matrix.
ED2 <- function(x) {
    .Call('_SC3_ED2', PACKAGE = 'SC3', x)
}

#' Consensus matrix computation
#' 
#' Computes consensus matrix given cluster labels
#' 
#' @param dat a matrix containing clustering solutions in columns
consmx <- function(dat) {
    .Call('_SC3_consmx', PACKAGE = 'SC3', dat)
}

#' Graph Laplacian calculation
#' 
#' Calculate graph Laplacian of a symmetrix matrix
#' 
#' @param A symmetric matrix
#' @export
norm_laplacian <- function(A) {
    .Call('_SC3_norm_laplacian', PACKAGE = 'SC3', A)
}

#' Matrix left-multiplied by its transpose
#' 
#' Given matrix A, the procedure returns A'A.
#' 
#' @param x Numeric matrix.
tmult <- function(x) {
    .Call('_SC3_tmult', PACKAGE = 'SC3', x)
}

